# Media3 v1.3.0 and ExoPlayer 2.19.1 with MediaMelon SDK

### Prerequisites

* Meida3 - v1.3.0 [sample application](https://mediamelon-builds.s3.amazonaws.com/MM-RELEASE-BUILDS/SDK_RELEASES/Android/2024-03-20/Media3Demo.zip).
* MediaMelon SmartSight SDK Maven dependencies or the provided `smartstreaming_release.aar`  AAR file is necessary.

### Step 1: Set up the build environment&#x20;

> `$MEDIA3PROJETC = {Media3 - v1.3.0}`

The SDK files should be added to the build environment and the required network permissions should be enabled.

**Using Maven:**

1. Add MediaMelon Maven dependency to `$MEDIA3PROJETC/demos/main/build.gradle`<br>

   ```java
   dependencies {
      ...
     //<!-- <MMSmartStreaming 1b> -->
     implementation 'com.github.MediamelonSDK:mm-sdk-media3-android:1.0.0'
     implementation 'com.google.android.exoplayer:exoplayer-core:2.19.1'
     implementation 'androidx.media3:media3-exoplayer:1.3.0'
     //<!-- </MMSmartStreaming 1b> --> 
   }
   ```

**Using AAR:**&#x20;

1. Copy `smartstreaming-release.aar` provided with the release package to the Media3 project. Example  `$MEDIA3PROJETC/demos/main/smartstreaming-release.aar`&#x20;
2. Add the following library to `$MEDIA3PROJETC/demos/main/build.gradle` :-

```java
dependencies {
  ...
  //<!-- <MMSmartStreaming 1b> -->
  api files ('smartstreaming-release.aar')
  implementation 'com.google.android.exoplayer:exoplayer-core:2.19.1'
  implementation 'androidx.media3:media3-exoplayer:1.3.0'
  //<!-- </MMSmartStreaming 1b> --> 
}
```

> To use MediaMelon SDK  you have to implement both media3 and Exoplayer dependencies.

Add network permissions to `$MEDIA3PROJETC/demos/main/src/main/AndroidManifest.xml`

```xml
<uses-permission android:name="android.permission.INTERNET"/>
<uses-permission android:name="android.permission.ACCESS_NETWORK_STATE"/>

<!-- <MMSmartStreaming 1c> -->
<uses-permission android:name="android.permission.ACCESS_WIFI_STATE" />
<!-- </MMSmartStreaming 1c> -->
```

### Step 2: Register SDK

The player application must register the SDK and provide player information once when the application launches. Please note that values provided in this integration step persist across video sessions. This is typically done when the player itself is initialized.&#x20;

#### Step 2a: Import packages

`$MEDIA3PROJETC/demos/main/src/main/java/androidx/media3/demo/main/PlayerActivity.java`

{% tabs %}
{% tab title="JAVA" %}

```java
// <MMSmartStreaming 2a>
import com.mediamelon.qubit.ep.ContentMetadata;
import com.mediamelon.smartstreaming.MMQBRMode;
import com.mediamelon.smartstreaming.MMSmartStreamingAdapter;
import com.mediamelon.smartstreaming.MMSmartStreamingFactory;
// </MMSmartStreaming 2a>
```

{% endtab %}
{% endtabs %}

#### Step 2b: Setup MediaMelon Adapter Object

&#x20;Setup MediaMelon Adapter Object  before `onCreate()` method in `$MEDIA3PROJETC/demos/main/src/main/java/androidx/media3/demo/main/PlayerActivity.java`

{% tabs %}
{% tab title="JAVA" %}

<pre class="language-java"><code class="lang-java">...

//&#x3C;MMSmartStreaming 2b>
MMSmartStreamingAdapter mmSmartStreamingAdapter;
// &#x3C;/MMSmartStreaming 2b> 

<strong>public void onCreate(Bundle savedInstanceState) {
</strong>  ... 
}
</code></pre>

{% endtab %}
{% endtabs %}

### Step 3: Registration, Initialize Session & Report User Intent to Playback <a href="#step-3-initialize-session-and-report-user-intent-to-playback" id="step-3-initialize-session-and-report-user-intent-to-playback"></a>

The player application must register the SDK and provide player information once after player is  initialized. Please note that values provided in this integration step persist across video sessions.

The SDK must be initialized at the start of each video session. Initialization includes setting the application context, initializing the playback session, and indicating the intent for playback with the SDK.

* Set the `isLive` variable in initializeSession() call , set true for live stream else false.

{% hint style="info" %}
The `enableLogTrace()` feature should be enabled for testing during the integration process. Set this to False before releasing the player to production
{% endhint %}

{% tabs %}
{% tab title="JAVA" %}

```java
protected boolean initializePlayer() {
   if (player == null) {
   Intent intent = getIntent();
   ...
   // after player is initialised and not null anymore
   initializeMediaMelon();
   ...
 }

void initializeMediaMelon(){
    // <MMSmartStreaming 3>
    mmSmartStreamingAdapter = MMSmartStreamingFactory.getInstance(player);
    mmSmartStreamingAdapter.enableLogTrace(true); //set to "false" before releasing player to production
    if (mmSmartStreamingAdapter.getRegistrationStatus() == false)
    { //Check if it is the first time Registration process is done
      mmSmartStreamingAdapter.setContext(getApplicationContext()); //Please make sure to provide the application's context here, and not the activity's context
      mmSmartStreamingAdapter.registerMMSmartStreaming("PLAYER_NAME", "CUSTOMER_ID", "SUBSCRIBER_ID", "DOMAIN_NAME", "SUBSCRIBER_TYPE", "SUBSCRIBER_TAG");
      mmSmartStreamingAdapter.reportPlayerInfo("PLAYEER_BRAND", "PLAYER_MODEL", "PLAYER_VERSION");
      mmSmartStreamingAdapter.reportAppInfo("APP_NAME","APP_VERSION");
      mmSmartStreamingAdapter.reportVideoQuality("VIDEO_QUALITY");
      mmSmartStreamingAdapter.setDeviceInfo("DEVICE_MARKETING_NAME");
    }
    String mediaUrl = String.valueOf(mediaItems.get(0).localConfiguration.uri); //getting the mediaURL from the application

    ContentMetadata cm  = new ContentMetadata();
    cm.assetName="ASSET_NAME";
    cm.assetId="ASSET_ID";
    cm.videoId="VIDEO_ID";
    cm.seriesTitle="SERIES_TITLE";
    cm.season="SEASON";
    cm.genre="GENRE";
    cm.episodeNumber="EPISODE_NUMBER";
    cm.drmProtection="DRM_PROTECTION";
    cm.contentType="CONTENT_TYPE";
    JSONObject contentMetadata = cm.getJSONObject();

    mmSmartStreamingAdapter.reportCustomMetadata("KEY1","VALUE1");
    mmSmartStreamingAdapter.initializeSession(MMQBRMode.QBRModeDisabled, mediaUrl, null, null, contentMetadata, false);
    mmSmartStreamingAdapter.reportUserInitiatedPlayback();
    // <MMSmartStreaming 3>
 }

```

{% endtab %}
{% endtabs %}

### Step 4: Report ended state when the player instance is released <a href="#step-5-report-ended-state-when-the-player-instance-is-released" id="step-5-report-ended-state-when-the-player-instance-is-released"></a>

In `$MEDIA3PROJETC/demos/main/src/main/java/androidx/media3/demo/main/PlayerActivity.java`&#x20;

{% tabs %}
{% tab title="JAVA" %}

```java
private void releasePlayer() {
    if (player != null) {
      updateTrackSelectorParameters();
      updateStartPosition();
      debugViewHelper.stop();
      debugViewHelper = null;
      player.release();
      player = null;
      mediaSource = null;
      trackSelector = null;
      // <MMSmartStreaming 4> Start
      mmSmartStreamingAdapter.reportPlayerState(false, Player.STATE_ENDED);
      // </MMSmartStreaming 4> End
    }
  }
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.mediamelon.com/mediamelon/smartsight-player-sdk-integration/android/media3-v1.3.0-and-exoplayer-2.19.1-with-mediamelon-sdk.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
